Index: xorg-server-7.2.0.0-1.5.99.1/render/render.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/render/render.c
+++ xorg-server-7.2.0.0-1.5.99.1/render/render.c
@@ -2736,6 +2736,8 @@ PanoramiXRenderCreatePicture (ClientPtr
     else
 	newPict->u.pict.root = FALSE;
 
+    newPict->u.pict.sourcePict = FALSE;
+
     for(j = 1; j < PanoramiXNumScreens; j++)
 	newPict->info[j].id = FakeClientID(client->index);
     
@@ -2766,10 +2768,18 @@ PanoramiXRenderChangePicture (ClientPtr
     VERIFY_XIN_PICTURE(pict, stuff->picture, client, DixWriteAccess,
 		       RenderErrBase + BadPicture);
     
-    FOR_NSCREENS_BACKWARD(j) {
-        stuff->picture = pict->info[j].id;
-        result = (*PanoramiXSaveRenderVector[X_RenderChangePicture]) (client);
-        if(result != Success) break;
+    if (pict->u.pict.sourcePict)
+    {
+	stuff->picture = pict->info[0].id;
+	result = (*PanoramiXSaveRenderVector[X_RenderChangePicture]) (client);
+    }
+    else
+    {
+	FOR_NSCREENS_BACKWARD(j) {
+	    stuff->picture = pict->info[j].id;
+	    result = (*PanoramiXSaveRenderVector[X_RenderChangePicture]) (client);
+	    if(result != Success) break;
+	}
     }
 
     return (result);
@@ -2807,11 +2817,19 @@ PanoramiXRenderSetPictureTransform (Clie
     
     VERIFY_XIN_PICTURE(pict, stuff->picture, client, DixWriteAccess,
 		       RenderErrBase + BadPicture);
-    
-    FOR_NSCREENS_BACKWARD(j) {
-        stuff->picture = pict->info[j].id;
-        result = (*PanoramiXSaveRenderVector[X_RenderSetPictureTransform]) (client);
-        if(result != Success) break;
+
+    if (pict->u.pict.sourcePict)
+    {
+	stuff->picture = pict->info[0].id;
+	result = (*PanoramiXSaveRenderVector[X_RenderSetPictureTransform]) (client);
+    }
+    else
+    {
+	FOR_NSCREENS_BACKWARD(j) {
+	    stuff->picture = pict->info[j].id;
+	    result = (*PanoramiXSaveRenderVector[X_RenderSetPictureTransform]) (client);
+	    if(result != Success) break;
+	}
     }
 
     return (result);
@@ -2830,9 +2848,9 @@ PanoramiXRenderSetPictureFilter (ClientP
 		       RenderErrBase + BadPicture);
     
     FOR_NSCREENS_BACKWARD(j) {
-        stuff->picture = pict->info[j].id;
-        result = (*PanoramiXSaveRenderVector[X_RenderSetPictureFilter]) (client);
-        if(result != Success) break;
+	stuff->picture = pict->info[j].id;
+	result = (*PanoramiXSaveRenderVector[X_RenderSetPictureFilter]) (client);
+	if(result != Success) break;
     }
 
     return (result);
@@ -2853,10 +2871,18 @@ PanoramiXRenderFreePicture (ClientPtr cl
 		       RenderErrBase + BadPicture);
     
 
-    FOR_NSCREENS_BACKWARD(j) {
-	stuff->picture = pict->info[j].id;
+    if (pict->u.pict.sourcePict)
+    {
+	stuff->picture = pict->info[0].id;
 	result = (*PanoramiXSaveRenderVector[X_RenderFreePicture]) (client);
-	if(result != Success) break;
+    }
+    else
+    {
+	FOR_NSCREENS_BACKWARD(j) {
+	    stuff->picture = pict->info[j].id;
+	    result = (*PanoramiXSaveRenderVector[X_RenderFreePicture]) (client);
+	    if(result != Success) break;
+	}
     }
 
     /* Since ProcRenderFreePicture is using FreeResource, it will free
@@ -3268,6 +3294,114 @@ PanoramiXRenderAddTraps (ClientPtr clien
     return result;
 }
 
+static int
+PanoramiXRenderCreateSolidFill (ClientPtr client)
+{
+    REQUEST(xRenderCreateSolidFillReq);
+    PanoramiXRes    *newPict;
+    int		    result = Success, j;
+
+    REQUEST_AT_LEAST_SIZE(xRenderCreateSolidFillReq);
+    if (!(newPict = (PanoramiXRes *) xalloc (sizeof (PanoramiXRes))))
+	return BadAlloc;
+
+    newPict->type = XRT_PICTURE;
+    for (j = 0; j < PanoramiXNumScreens; j++)
+	newPict->info[j].id = stuff->pid;
+
+    newPict->u.pict.root       = FALSE;
+    newPict->u.pict.sourcePict = TRUE;
+
+    result = (*PanoramiXSaveRenderVector[X_RenderCreateSolidFill]) (client);
+    if (result == Success)
+	AddResource (newPict->info[0].id, XRT_PICTURE, newPict);
+    else
+	xfree (newPict);
+
+    return result;
+}
+
+static int
+PanoramiXRenderCreateLinearGradient (ClientPtr client)
+{
+    REQUEST(xRenderCreateLinearGradientReq);
+    PanoramiXRes    *newPict;
+    int		    result = Success, j;
+
+    REQUEST_AT_LEAST_SIZE(xRenderCreateLinearGradientReq);
+    if (!(newPict = (PanoramiXRes *) xalloc (sizeof (PanoramiXRes))))
+	return BadAlloc;
+
+    newPict->type = XRT_PICTURE;
+    for (j = 0; j < PanoramiXNumScreens; j++)
+	newPict->info[j].id = stuff->pid;
+
+    newPict->u.pict.root       = FALSE;
+    newPict->u.pict.sourcePict = TRUE;
+
+    result = (*PanoramiXSaveRenderVector[X_RenderCreateLinearGradient]) (client);
+    if (result == Success)
+	AddResource (newPict->info[0].id, XRT_PICTURE, newPict);
+    else
+	xfree (newPict);
+
+    return result;
+}
+
+static int
+PanoramiXRenderCreateRadialGradient (ClientPtr client)
+{
+    REQUEST(xRenderCreateRadialGradientReq);
+    PanoramiXRes    *newPict;
+    int		    result = Success, j;
+
+    REQUEST_AT_LEAST_SIZE(xRenderCreateRadialGradientReq);
+    if (!(newPict = (PanoramiXRes *) xalloc (sizeof (PanoramiXRes))))
+	return BadAlloc;
+
+    newPict->type = XRT_PICTURE;
+    for (j = 0; j < PanoramiXNumScreens; j++)
+	newPict->info[j].id = stuff->pid;
+
+    newPict->u.pict.root       = FALSE;
+    newPict->u.pict.sourcePict = TRUE;
+
+    result = (*PanoramiXSaveRenderVector[X_RenderCreateRadialGradient]) (client);
+    if (result == Success)
+	AddResource (newPict->info[0].id, XRT_PICTURE, newPict);
+    else
+	xfree (newPict);
+
+    return result;
+}
+
+static int
+PanoramiXRenderCreateConicalGradient (ClientPtr client)
+{
+    REQUEST(xRenderCreateConicalGradientReq);
+    PanoramiXRes    *newPict;
+    int		    result = Success, j;
+
+    REQUEST_AT_LEAST_SIZE(xRenderCreateConicalGradientReq);
+    if (!(newPict = (PanoramiXRes *) xalloc (sizeof (PanoramiXRes))))
+	return BadAlloc;
+
+    newPict->type = XRT_PICTURE;
+    for (j = 0; j < PanoramiXNumScreens; j++)
+	newPict->info[j].id = stuff->pid;
+
+    newPict->u.pict.root       = FALSE;
+    newPict->u.pict.sourcePict = TRUE;
+
+    result = (*PanoramiXSaveRenderVector[X_RenderCreateConicalGradient]) (client);
+    if (result == Success)
+	AddResource (newPict->info[0].id, XRT_PICTURE, newPict);
+    else
+	xfree (newPict);
+
+    return result;
+}
+
 void
 PanoramiXRenderInit (void)
 {
@@ -3296,6 +3430,10 @@ PanoramiXRenderInit (void)
     ProcRenderVector[X_RenderTriStrip] = PanoramiXRenderTriStrip;
     ProcRenderVector[X_RenderTriFan] = PanoramiXRenderTriFan;
     ProcRenderVector[X_RenderAddTraps] = PanoramiXRenderAddTraps;
+    ProcRenderVector[X_RenderCreateSolidFill] = PanoramiXRenderCreateSolidFill;
+    ProcRenderVector[X_RenderCreateLinearGradient] = PanoramiXRenderCreateLinearGradient;
+    ProcRenderVector[X_RenderCreateRadialGradient] = PanoramiXRenderCreateRadialGradient;
+    ProcRenderVector[X_RenderCreateConicalGradient] = PanoramiXRenderCreateConicalGradient;
 }
 
 void
Index: xorg-server-7.2.0.0-1.5.99.1/xfixes/region.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/xfixes/region.c
+++ xorg-server-7.2.0.0-1.5.99.1/xfixes/region.c
@@ -864,3 +864,84 @@ SProcXFixesExpandRegion (ClientPtr clien
     return (*ProcXFixesVector[stuff->xfixesReqType]) (client);
 }
 
+#ifdef PANORAMIX
+#include "panoramiX.h"
+#include "panoramiXsrv.h"
+
+#define VERIFY_XIN_PICTURE(pPicture, pid, client, mode, err) {\
+    pPicture = SecurityLookupIDByType(client, pid, XRT_PICTURE, mode);\
+    if (!pPicture) { \
+	client->errorValue = pid; \
+	return err; \
+    } \
+}
+
+extern unsigned long	XRT_PICTURE;
+
+extern int (*PanoramiXSaveXFixesVector[XFixesNumberRequests])(ClientPtr);
+
+int
+PanoramiXFixesSetGCClipRegion (ClientPtr client)
+{
+    REQUEST(xXFixesSetGCClipRegionReq);
+    int		    result = Success, j;
+    PanoramiXRes    *gc;
+    REQUEST_SIZE_MATCH(xXFixesSetGCClipRegionReq);
+
+    if(!(gc = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->gc, XRT_GC, DixReadAccess)))
+	return BadGC;
+
+    FOR_NSCREENS_BACKWARD(j) {
+        stuff->gc = gc->info[j].id;
+        result = (*PanoramiXSaveXFixesVector[X_XFixesSetGCClipRegion]) (client);
+        if(result != Success) break;
+    }
+
+    return (result);
+}
+
+int
+PanoramiXFixesSetWindowShapeRegion (ClientPtr client)
+{
+    int		    result = Success, j;
+    PanoramiXRes    *win;
+    REQUEST(xXFixesSetWindowShapeRegionReq);
+
+    REQUEST_SIZE_MATCH(xXFixesSetWindowShapeRegionReq);
+
+    if(!(win = (PanoramiXRes *)SecurityLookupIDByType(
+	     client, stuff->dest, XRT_WINDOW, DixWriteAccess)))
+	return BadWindow;
+
+    FOR_NSCREENS_FORWARD(j) {
+	stuff->dest = win->info[j].id;
+	result = (*PanoramiXSaveXFixesVector[X_XFixesSetWindowShapeRegion]) (client);
+        if(result != Success) break;
+    }
+
+    return (result);
+}
+
+int
+PanoramiXFixesSetPictureClipRegion (ClientPtr client)
+{
+    REQUEST(xXFixesSetPictureClipRegionReq);
+    int		    result = Success, j;
+    PanoramiXRes    *pict;
+
+    REQUEST_SIZE_MATCH (xXFixesSetPictureClipRegionReq);
+
+    VERIFY_XIN_PICTURE(pict, stuff->picture, client, DixWriteAccess,
+		       RenderErrBase + BadPicture);
+
+    FOR_NSCREENS_BACKWARD(j) {
+        stuff->picture = pict->info[j].id;
+	result = (*PanoramiXSaveXFixesVector[X_XFixesSetPictureClipRegion]) (client);
+        if(result != Success) break;
+    }
+
+    return (result);
+}
+
+#endif
Index: xorg-server-7.2.0.0-1.5.99.1/xfixes/xfixes.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/xfixes/xfixes.c
+++ xorg-server-7.2.0.0-1.5.99.1/xfixes/xfixes.c
@@ -259,3 +259,33 @@ XFixesExtensionInit(void)
 	    (EventSwapPtr) SXFixesCursorNotifyEvent;
     }
 }
+
+#ifdef PANORAMIX
+
+int (*PanoramiXSaveXFixesVector[XFixesNumberRequests])(ClientPtr);
+
+void
+PanoramiXFixesInit (void)
+{
+    int i;
+
+    for (i = 0; i < XFixesNumberRequests; i++)
+	PanoramiXSaveXFixesVector[i] = ProcXFixesVector[i];
+    /*
+     * Stuff in Xinerama aware request processing hooks
+     */
+    ProcXFixesVector[X_XFixesSetGCClipRegion] = PanoramiXFixesSetGCClipRegion;
+    ProcXFixesVector[X_XFixesSetWindowShapeRegion] = PanoramiXFixesSetWindowShapeRegion;
+    ProcXFixesVector[X_XFixesSetPictureClipRegion] = PanoramiXFixesSetPictureClipRegion;
+}
+
+void
+PanoramiXFixesReset (void)
+{
+    int i;
+
+    for (i = 0; i < XFixesNumberRequests; i++)
+	ProcXFixesVector[i] = PanoramiXSaveXFixesVector[i];
+}
+
+#endif
Index: xorg-server-7.2.0.0-1.5.99.1/xfixes/xfixesint.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/xfixes/xfixesint.h
+++ xorg-server-7.2.0.0-1.5.99.1/xfixes/xfixesint.h
@@ -255,6 +255,17 @@ ProcXFixesExpandRegion (ClientPtr client
 int
 SProcXFixesExpandRegion (ClientPtr client);
 
+#ifdef PANORAMIX
+int
+PanoramiXFixesSetGCClipRegion (ClientPtr client);
+
+int
+PanoramiXFixesSetWindowShapeRegion (ClientPtr client);
+
+int
+PanoramiXFixesSetPictureClipRegion (ClientPtr client);
+#endif
+
 /* Cursor Visibility (Version 4) */
 
 int 
@@ -269,4 +280,9 @@ ProcXFixesShowCursor (ClientPtr client);
 int 
 SProcXFixesShowCursor (ClientPtr client);
 
+#ifdef PANORAMIX
+void PanoramiXFixesInit (void);
+void PanoramiXFixesReset (void);
+#endif
+
 #endif /* _XFIXESINT_H_ */
Index: xorg-server-7.2.0.0-1.5.99.1/xkb/xkb.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/xkb/xkb.c
+++ xorg-server-7.2.0.0-1.5.99.1/xkb/xkb.c
@@ -6125,66 +6125,50 @@ int rc;
 
 /***====================================================================***/
 
+int (*ProcXkbVector[])(ClientPtr) = {
+    ProcXkbUseExtension,
+    ProcXkbSelectEvents,
+    0,
+    ProcXkbBell,
+    ProcXkbGetState,
+    ProcXkbLatchLockState,
+    ProcXkbGetControls,
+    ProcXkbSetControls,
+    ProcXkbGetMap,
+    ProcXkbSetMap,
+    ProcXkbGetCompatMap,
+    ProcXkbSetCompatMap,
+    ProcXkbGetIndicatorState,
+    ProcXkbGetIndicatorMap,
+    ProcXkbSetIndicatorMap,
+    ProcXkbGetNamedIndicator,
+    ProcXkbSetNamedIndicator,
+    ProcXkbGetNames,
+    ProcXkbSetNames,
+    ProcXkbGetGeometry,
+    ProcXkbSetGeometry,
+    ProcXkbPerClientFlags,
+    ProcXkbListComponents,
+    ProcXkbGetKbdByName,
+    ProcXkbGetDeviceInfo,
+    ProcXkbSetDeviceInfo
+};
+
 static int
 ProcXkbDispatch (ClientPtr client)
 {
     REQUEST(xReq);
     switch (stuff->data)
     {
-    case X_kbUseExtension:
-	return ProcXkbUseExtension(client);
-    case X_kbSelectEvents:
-	return ProcXkbSelectEvents(client);
-    case X_kbBell:
-	return ProcXkbBell(client);
-    case X_kbGetState:
-	return ProcXkbGetState(client);
-    case X_kbLatchLockState:
-	return ProcXkbLatchLockState(client);
-    case X_kbGetControls:
-	return ProcXkbGetControls(client);
-    case X_kbSetControls:
-	return ProcXkbSetControls(client);
-    case X_kbGetMap:
-	return ProcXkbGetMap(client);
-    case X_kbSetMap:
-	return ProcXkbSetMap(client);
-    case X_kbGetCompatMap:
-	return ProcXkbGetCompatMap(client);
-    case X_kbSetCompatMap:
-	return ProcXkbSetCompatMap(client);
-    case X_kbGetIndicatorState:
-	return ProcXkbGetIndicatorState(client);
-    case X_kbGetIndicatorMap:
-	return ProcXkbGetIndicatorMap(client);
-    case X_kbSetIndicatorMap:
-	return ProcXkbSetIndicatorMap(client);
-    case X_kbGetNamedIndicator:
-	return ProcXkbGetNamedIndicator(client);
-    case X_kbSetNamedIndicator:
-	return ProcXkbSetNamedIndicator(client);
-    case X_kbGetNames:
-	return ProcXkbGetNames(client);
-    case X_kbSetNames:
-	return ProcXkbSetNames(client);
-    case X_kbGetGeometry:
-	return ProcXkbGetGeometry(client);
-    case X_kbSetGeometry:
-	return ProcXkbSetGeometry(client);
-    case X_kbPerClientFlags:
-	return ProcXkbPerClientFlags(client);
-    case X_kbListComponents:
-	return ProcXkbListComponents(client);
-    case X_kbGetKbdByName:
-	return ProcXkbGetKbdByName(client);
-    case X_kbGetDeviceInfo:
-	return ProcXkbGetDeviceInfo(client);
-    case X_kbSetDeviceInfo:
-	return ProcXkbSetDeviceInfo(client);
     case X_kbSetDebuggingFlags:
 	return ProcXkbSetDebuggingFlags(client);
     default:
-	return BadRequest;
+	if (stuff->data >=
+	    (sizeof (ProcXkbVector) / sizeof (ProcXkbVector[0])) ||
+	    !ProcXkbVector[stuff->data])
+	    return BadRequest;
+
+	return (ProcXkbVector[stuff->data]) (client);
     }
 }
 
Index: xorg-server-7.2.0.0-1.5.99.1/xkb/xkbSwap.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/xkb/xkbSwap.c
+++ xorg-server-7.2.0.0-1.5.99.1/xkb/xkbSwap.c
@@ -531,65 +531,49 @@ register int	n;
     return ProcXkbSetDebuggingFlags(client);
 }
 
+int (*SProcXkbVector[])(ClientPtr) = {
+    SProcXkbUseExtension,
+    SProcXkbSelectEvents,
+    0,
+    SProcXkbBell,
+    SProcXkbGetState,
+    SProcXkbLatchLockState,
+    SProcXkbGetControls,
+    SProcXkbSetControls,
+    SProcXkbGetMap,
+    SProcXkbSetMap,
+    SProcXkbGetCompatMap,
+    SProcXkbSetCompatMap,
+    SProcXkbGetIndicatorState,
+    SProcXkbGetIndicatorMap,
+    SProcXkbSetIndicatorMap,
+    SProcXkbGetNamedIndicator,
+    SProcXkbSetNamedIndicator,
+    SProcXkbGetNames,
+    SProcXkbSetNames,
+    SProcXkbGetGeometry,
+    SProcXkbSetGeometry,
+    SProcXkbPerClientFlags,
+    SProcXkbListComponents,
+    SProcXkbGetKbdByName,
+    SProcXkbGetDeviceInfo,
+    SProcXkbSetDeviceInfo
+};
+
 int
 SProcXkbDispatch (ClientPtr client)
 {
     REQUEST(xReq);
     switch (stuff->data)
     {
-    case X_kbUseExtension:
-	return SProcXkbUseExtension(client);
-    case X_kbSelectEvents:
-	return SProcXkbSelectEvents(client);
-    case X_kbBell:
-	return SProcXkbBell(client);
-    case X_kbGetState:
-	return SProcXkbGetState(client);
-    case X_kbLatchLockState:
-	return SProcXkbLatchLockState(client);
-    case X_kbGetControls:
-	return SProcXkbGetControls(client);
-    case X_kbSetControls:
-	return SProcXkbSetControls(client);
-    case X_kbGetMap:
-	return SProcXkbGetMap(client);
-    case X_kbSetMap:
-	return SProcXkbSetMap(client);
-    case X_kbGetCompatMap:
-	return SProcXkbGetCompatMap(client);
-    case X_kbSetCompatMap:
-	return SProcXkbSetCompatMap(client);
-    case X_kbGetIndicatorState:
-	return SProcXkbGetIndicatorState(client);
-    case X_kbGetIndicatorMap:
-	return SProcXkbGetIndicatorMap(client);
-    case X_kbSetIndicatorMap:
-	return SProcXkbSetIndicatorMap(client);
-    case X_kbGetNamedIndicator:
-	return SProcXkbGetNamedIndicator(client);
-    case X_kbSetNamedIndicator:
-	return SProcXkbSetNamedIndicator(client);
-    case X_kbGetNames:
-	return SProcXkbGetNames(client);
-    case X_kbSetNames:
-	return SProcXkbSetNames(client);
-    case X_kbGetGeometry:
-	return SProcXkbGetGeometry(client);
-    case X_kbSetGeometry:
-	return SProcXkbSetGeometry(client);
-    case X_kbPerClientFlags:
-	return SProcXkbPerClientFlags(client);
-    case X_kbListComponents:
-	return SProcXkbListComponents(client);
-    case X_kbGetKbdByName:
-	return SProcXkbGetKbdByName(client);
-    case X_kbGetDeviceInfo:
-	return SProcXkbGetDeviceInfo(client);
-    case X_kbSetDeviceInfo:
-	return SProcXkbSetDeviceInfo(client);
     case X_kbSetDebuggingFlags:
 	return SProcXkbSetDebuggingFlags(client);
     default:
-	return BadRequest;
+	if (stuff->data >=
+	    (sizeof (SProcXkbVector) / sizeof (SProcXkbVector[0])) ||
+	    !SProcXkbVector[stuff->data])
+	    return BadRequest;
+
+	return (SProcXkbVector[stuff->data]) (client);
     }
 }
